﻿local Engine, Api, Locale, Settings = unpack(Immersive)

local Default = Engine:GetModule("Default")

-- Registers the element.
function Default:RegisterMainMenuBar()
	local settings = Settings:Get(self.Name).Elements["MainMenuBar"]
	local bar = Api:RegisterElement("MainMenuBar", settings)
	
	-- Add frames
	-- MainMenuBar encapsulates all the multibar frames including the
	-- side bars. Instead we will only add the parts that make up the
	-- main multibar, the micromenu, the backpacks and the XP/Rep bars.
	bar:AddFrame(CharacterMicroButton)
	bar:AddFrame(SpellbookMicroButton)
	bar:AddFrame(TalentMicroButton)
	bar:AddFrame(AchievementMicroButton)
	bar:AddFrame(QuestLogMicroButton)
	bar:AddFrame(GuildMicroButton)
	bar:AddFrame(LFDMicroButton)
	bar:AddFrame(EJMicroButton)
	bar:AddFrame(CollectionsMicroButton)
	bar:AddFrame(MainMenuMicroButton)
	bar:AddFrame(HelpMicroButton)
	bar:AddFrame(StoreMicroButton)
	bar:AddFrame(ActionButton1)
	bar:AddFrame(ActionButton2)
	bar:AddFrame(ActionButton3)
	bar:AddFrame(ActionButton4)
	bar:AddFrame(ActionButton5)
	bar:AddFrame(ActionButton6)
	bar:AddFrame(ActionButton7)
	bar:AddFrame(ActionButton8)
	bar:AddFrame(ActionButton9)
	bar:AddFrame(ActionButton10)
	bar:AddFrame(ActionButton11)
	bar:AddFrame(ActionButton12)
	bar:AddFrame(ActionBarUpButton)
	bar:AddFrame(ActionBarDownButton)
	bar:AddFrame(MainMenuBarBackpackButton)
	bar:AddFrame(CharacterBag0Slot)
	bar:AddFrame(CharacterBag1Slot)
	bar:AddFrame(CharacterBag2Slot)
	bar:AddFrame(CharacterBag3Slot)
	bar:AddFrame(MainMenuExpBar)
	bar:AddFrame(ReputationWatchBar)

	bar:AddFrame(MainMenuBarLeftEndCap)
	bar:AddFrame(MainMenuBarRightEndCap)
	bar:AddFrame(MainMenuBarTexture0)
	bar:AddFrame(MainMenuBarTexture1)
	bar:AddFrame(MainMenuBarTexture2)
	bar:AddFrame(MainMenuBarTexture3)
	bar:AddFrame(MainMenuBarPageNumber)
	bar:AddFrame(MainMenuMaxLevelBar0)
	bar:AddFrame(MainMenuMaxLevelBar1)
	bar:AddFrame(MainMenuMaxLevelBar2)
	bar:AddFrame(MainMenuMaxLevelBar3)
	
	-- Add conditions
	bar:AddConditionRange(settings.Conditions)

	-- Add hotspots
	bar:AddHotspot(MainMenuBar:GetRect())

	-- Disable ITEM_PUSH animation
	CharacterBag0Slot:UnregisterEvent("ITEM_PUSH")
	CharacterBag1Slot:UnregisterEvent("ITEM_PUSH")
	CharacterBag2Slot:UnregisterEvent("ITEM_PUSH")
	CharacterBag3Slot:UnregisterEvent("ITEM_PUSH")

	GameMenuFrame:HookScript("OnShow", function()
		if bar.State == 0 and StoreMicroButton:GetAlpha() > 0 then -- 0 = HIDDEN
			StoreMicroButton:SetAlpha(0)
		end
	end)
end

-- Unregisters the element.
function Default:UnregisterMainMenuBar()
	CharacterBag3Slot:RegisterEvent("ITEM_PUSH")
	CharacterBag2Slot:RegisterEvent("ITEM_PUSH")
	CharacterBag1Slot:RegisterEvent("ITEM_PUSH")
	CharacterBag0Slot:RegisterEvent("ITEM_PUSH")

	Api:UnregisterElement("MainMenuBar")
end